﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        ScriptManager.ScriptResourceMapping.AddDefinition("jquery",
    new ScriptResourceDefinition
    {
        Path = "~/scripts/jquery-1.7.2.min.js",
        DebugPath = "~/scripts/jquery-1.7.2.min.js",
        CdnPath = "http://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.4.1.min.js",
        CdnDebugPath = "http://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.4.1.js"
    });

        DataSet set = new DataSet();
        //Add two tables
        set.Tables.Add(BuildTable("Parent"));
        set.Tables.Add(BuildChildTable("Child"));

        //Create relations
        DataColumn parentColumn = set.Tables[0].Columns["id"];
        DataColumn childColumn = set.Tables[1].Columns["relation"];
        DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
        set.Relations.Add(relation);

        this.WebHierarchicalDataGrid1.DataSource = set;
    }
    private DataTable BuildTable(string name)
    {

        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "Sum";
        column.AutoIncrement = false;
        column.Caption = "Sum";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            if (i == 0)
            {

                row["Sum"] = 45;
            }

            table.Rows.Add(row);
        }
        return table;

    }

    private DataTable BuildChildTable(string name)
    {
        System.Data.DataTable table = new DataTable(name);
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "relation";
        column.AutoIncrement = false;
        column.Caption = "relation";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 100; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] =  i; 
            
            if ((i < 10) && (i >= 0))
            {

                row["relation"] = 0;
            }

            table.Rows.Add(row);
        }
        return table;

    }

    protected void WebHierarchicalDataGrid1_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {

    }

    protected void ServerValidation(object source, ServerValidateEventArgs arguments)
    {

        

    }
}